/* ------------------------------------------------------------------ */
/*      item            : EndRole.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : EndRole.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated EndRole.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_EndRole
#endif

#ifdef MASTER_DCO_EndRole
#undef MASTER_DCO_EndRole
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Defines different possible levels for logging data
    */
struct EndRole
{
  /** typedef for internal reference */
  typedef EndRole __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


/** Different log levels
 */
  enum Type {
    /** only emitting */
    Sending,
    /** only receiving */
    Receiving,
    /** both */
    SendingReceiving,
    /** uninitialised */
    None
  };

  /** The actual role */
  Type t;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  EndRole();

  /** Constructor with arguments */
  EndRole(
        const Type& t);

  /** copy constructor. */
  EndRole(const EndRole& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an EndRole from amorphous storage. */
  EndRole(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~EndRole();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, EndRole*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the EndRole into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the EndRole into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const EndRole& ref) const;

  /** unpacks the EndRole from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for EndRole
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const EndRole& o) const;

  /** Test for inequality. */
  inline bool operator != (const EndRole& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  EndRole& operator=(const EndRole& o);

  /** prints the EndRole to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "EndRoleExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::EndRole& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::EndRole& o,
                         const dueca::EndRole& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::EndRole& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::EndRole& o)
{ o.unPackDataDiff(s); }
#endif

namespace dueca {
  const char* const getString(const EndRole::Type &o);
  void readFromString(EndRole::Type &o, const std::string& s);
  void getFirst(EndRole::Type &o);
  bool getNext(EndRole::Type &o);

  /** This function retrieves the classname of an EndRole::Type */
  template <>
  const char* getclassname<EndRole::Type>();
  /** This function retrieves a string with int rep EndRole::Type */
  template <>
  const char* getenumintrep<EndRole::Type>();
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::EndRole::Type &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::EndRole::Type &o);
#endif

PRINT_NS_START;
/** Print an object of type EndRole::Type */
inline std::ostream&
operator << (std::ostream& s, const dueca::EndRole::Type& o)
{ return s << dueca::getString(o); }
/** Read an object of type EndRole::Type */
inline std::istream&
/** Read an enum of type EndRole::Type */
operator >> (std::istream& s, dueca::EndRole::Type& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::EndRole& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::EndRole>();
template <>
inline const char* dueca::getclassname<const dueca::EndRole>()
{ return dueca::getclassname<dueca::EndRole>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    EndRole is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::EndRole> : public dco_isnested { };
template <>
struct dco_nested<dueca::EndRole::Type> : public dco_isenum { };
};

#endif


