/* ------------------------------------------------------------------ */
/*      item            : NameSet.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        from item       : NameSet.dco
        date            : 130928
        category        : comm object specification
        description     : Basic named object or channel
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
        language        : C++
        documentation   : DUECA_API
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated NameSet.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_NameSet
#endif
#include <string>
#ifdef MASTER_DCO_NameSet
#undef MASTER_DCO_NameSet
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Name tuple as used in DUECA. The tuple is typically written in URL-type
    fashion, with the data class type before the dots, e.g.,
    MyDataClass://entity/part, or MyDataClass://something
   
    Originally, the naming in DUECA was limited to three-part names
      <ol>
      <li> Entity. The name of the (bigger) entity this object (module
           or channel) belongs or corresponds to.
      <li> Class. The type of thing it is. The module class name for a
           module, or the data class name for a channel.
      <li> Part. In order to distinguish between multiple
           channels/modules of the same type within one Entity.
      </ol>
   
    This is now re-coded to a name of Class://Entity/Part, and if part is
    omitted, to Class://Entity
    */
struct NameSet
{
  /** typedef for internal reference */
  typedef NameSet __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** A class member */
  std::string name;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  NameSet();

  /** Constructor with arguments */
  NameSet(
        const std::string& name);

  /** copy constructor. */
  NameSet(const NameSet& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an NameSet from amorphous storage. */
  NameSet(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~NameSet();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, NameSet*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the NameSet into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the NameSet into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const NameSet& ref) const;

  /** unpacks the NameSet from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for NameSet
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const NameSet& o) const;

  /** Test for inequality. */
  inline bool operator != (const NameSet& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  NameSet& operator=(const NameSet& o);

  /** prints the NameSet to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "NameSetExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::NameSet& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::NameSet& o,
                         const dueca::NameSet& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::NameSet& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::NameSet& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::NameSet& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::NameSet>();
template <>
inline const char* dueca::getclassname<const dueca::NameSet>()
{ return dueca::getclassname<dueca::NameSet>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    NameSet is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::NameSet> : public dco_isnested { };
};

#endif


