/* ------------------------------------------------------------------ */
/*      item            : ObjectInfo.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ObjectInfo.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Information about objects
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ObjectInfo.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_ObjectInfo
#endif
#include <GlobalId.hxx>
#include <NameSet.hxx>
#ifdef MASTER_DCO_ObjectInfo
#undef MASTER_DCO_ObjectInfo
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Information about objects.
    */
struct ObjectInfo
{
  /** typedef for internal reference */
  typedef ObjectInfo __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** unique id for the object */
  GlobalId id;

  /** name of the object */
  NameSet name_set;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ObjectInfo();

  /** Constructor with arguments */
  ObjectInfo(
        const GlobalId& id,
        const NameSet& name_set);

  /** copy constructor. */
  ObjectInfo(const ObjectInfo& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ObjectInfo from amorphous storage. */
  ObjectInfo(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ObjectInfo();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ObjectInfo*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ObjectInfo into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ObjectInfo into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ObjectInfo& ref) const;

  /** unpacks the ObjectInfo from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ObjectInfo
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ObjectInfo& o) const;

  /** Test for inequality. */
  inline bool operator != (const ObjectInfo& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ObjectInfo& operator=(const ObjectInfo& o);

  /** prints the ObjectInfo to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ObjectInfo& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ObjectInfo& o,
                         const dueca::ObjectInfo& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ObjectInfo& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ObjectInfo& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ObjectInfo& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ObjectInfo>();
template <>
inline const char* dueca::getclassname<const dueca::ObjectInfo>()
{ return dueca::getclassname<dueca::ObjectInfo>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ObjectInfo is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ObjectInfo> : public dco_isnested { };
};

#endif


