/* ------------------------------------------------------------------ */
/*      item            : ScriptLine.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ScriptLine.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Start-up communication
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ScriptLine.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_ScriptLine
#endif
#include <stringoptions.h>
#ifdef MASTER_DCO_ScriptLine
#undef MASTER_DCO_ScriptLine
#undef NESTED_DCO
#endif

namespace dueca {
 
/** A scheme line, for sending over the dueca.mod file script
    */
struct ScriptLine
{
  /** typedef for internal reference */
  typedef ScriptLine __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** line in file. */
  vstring line;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ScriptLine();

  /** Constructor with arguments */
  ScriptLine(
        const vstring& line);

  /** copy constructor. */
  ScriptLine(const ScriptLine& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ScriptLine from amorphous storage. */
  ScriptLine(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ScriptLine();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ScriptLine*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ScriptLine into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ScriptLine into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ScriptLine& ref) const;

  /** unpacks the ScriptLine from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ScriptLine
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ScriptLine& o) const;

  /** Test for inequality. */
  inline bool operator != (const ScriptLine& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ScriptLine& operator=(const ScriptLine& o);

  /** prints the ScriptLine to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ScriptLine& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ScriptLine& o,
                         const dueca::ScriptLine& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ScriptLine& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ScriptLine& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ScriptLine& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ScriptLine>();
template <>
inline const char* dueca::getclassname<const dueca::ScriptLine>()
{ return dueca::getclassname<dueca::ScriptLine>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ScriptLine is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ScriptLine> : public dco_isnested { };
};

#endif


