/* ------------------------------------------------------------------ */
/*      item            : SyncReport.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : SyncReport.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Report on synchronisation state
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated SyncReport.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_SyncReport
#endif

#ifdef MASTER_DCO_SyncReport
#undef MASTER_DCO_SyncReport
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Report on synchronization of DUECA processes
    */
struct SyncReport
{
  /** typedef for internal reference */
  typedef SyncReport __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** current difference between master and node logical clock */
  int32_t difference;

  /** number of times the scheduler woke too early */
  int32_t no_early;

  /** number of times the scheduler woke too late */
  int32_t no_late;

  /** number of times a wait had to be cancelled, since the loop was
      too late */
  int32_t no_cancelled_waits;

  /** number of time a double wait was needed to sync with the master */
  int32_t no_double_waits;

  /** earliest waking of scheduler relative to ideal wake time */
  int32_t earliest_wrt_ideal;

  /** latest waking of scheduler relative to ideal wake time */
  int32_t latest_wrt_ideal;

  /** average waking of scheduler relative to ideal wake time */
  int32_t average_step_size;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  SyncReport();

  /** Constructor with arguments */
  SyncReport(
        const int32_t& difference,
        const int32_t& no_early,
        const int32_t& no_late,
        const int32_t& no_cancelled_waits,
        const int32_t& no_double_waits,
        const int32_t& earliest_wrt_ideal,
        const int32_t& latest_wrt_ideal,
        const int32_t& average_step_size);

  /** copy constructor. */
  SyncReport(const SyncReport& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an SyncReport from amorphous storage. */
  SyncReport(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~SyncReport();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, SyncReport*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the SyncReport into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the SyncReport into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const SyncReport& ref) const;

  /** unpacks the SyncReport from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for SyncReport
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const SyncReport& o) const;

  /** Test for inequality. */
  inline bool operator != (const SyncReport& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  SyncReport& operator=(const SyncReport& o);

  /** prints the SyncReport to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::SyncReport& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::SyncReport& o,
                         const dueca::SyncReport& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::SyncReport& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::SyncReport& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::SyncReport& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::SyncReport>();
template <>
inline const char* dueca::getclassname<const dueca::SyncReport>()
{ return dueca::getclassname<dueca::SyncReport>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    SyncReport is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::SyncReport> : public dco_isnested { };
};

#endif


