/* ------------------------------------------------------------------ */
/*      item            : TokenCountResult.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : TokenCountResult.dco
        made by         : Rene' van Paassen
        date            : 180509
        description     : Return a count of entry writes/reads
        copyright       : (c) 2018-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated TokenCountResult.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_TokenCountResult
#endif
#include <inttypes.h>
#ifdef MASTER_DCO_TokenCountResult
#undef MASTER_DCO_TokenCountResult
#undef NESTED_DCO
#endif

namespace dueca {
 
/** An automatically generated class
    */
struct TokenCountResult
{
  /** typedef for internal reference */
  typedef TokenCountResult __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** ID, based on the creation ID issued to a read token, or
      zero if the count refers to the write token/entry */
  uint32_t clientid;

  /** list of counts, for reading or writing */
  uint32_t count;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  TokenCountResult();

  /** Constructor with arguments */
  TokenCountResult(
        const uint32_t& clientid,
        const uint32_t& count);

  /** copy constructor. */
  TokenCountResult(const TokenCountResult& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an TokenCountResult from amorphous storage. */
  TokenCountResult(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~TokenCountResult();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, TokenCountResult*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the TokenCountResult into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the TokenCountResult into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const TokenCountResult& ref) const;

  /** unpacks the TokenCountResult from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for TokenCountResult
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const TokenCountResult& o) const;

  /** Test for inequality. */
  inline bool operator != (const TokenCountResult& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  TokenCountResult& operator=(const TokenCountResult& o);

  /** prints the TokenCountResult to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::TokenCountResult& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::TokenCountResult& o,
                         const dueca::TokenCountResult& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::TokenCountResult& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::TokenCountResult& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::TokenCountResult& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::TokenCountResult>();
template <>
inline const char* dueca::getclassname<const dueca::TokenCountResult>()
{ return dueca::getclassname<dueca::TokenCountResult>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    TokenCountResult is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::TokenCountResult> : public dco_isnested { };
};

#endif


