/* ------------------------------------------------------------------   */
/*      item            : dueca-version.h.in
        made by         : Rene' van Paassen
        date            : 20010308
        category        : header file (in)
        description     : Defines the current version
        documentation   : in DUECA_API, but directly from configure
        copyright       : (c) 2001 TUDelft-AE-C&S
        copyright       : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

/** \file dueca-version.h

    This file defines the current DUECA version and macros for version
    testing
*/

#ifndef dueca_version_h
#define dueca_version_h

/** Numerical single version number */
#define DUECA_VERSION_NUM \
  4*1000000 +  \
  2*1000 +     \
  1

/** DUECA's major version number */
#define DUECA_VERMAJOR 4
/** DUECA's minor version number */
#define DUECA_VERMINOR 2
/** DUECA's revision number */
#define DUECA_REVISION 1
/** Version as a complete string */
#define DUECA_VERSIONSTRING "4.2.1"

/** Calculate the numerical version */
#define DUECA_VERSION(MAJOR,MINOR,REVISION) \
  (MAJOR*1000000+MINOR*1000+REVISION)

#endif
