/* ------------------------------------------------------------------ */
/*      item            : UDPPeerInfo.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : UDPPeerInfo.dco
        made by         : Rene' van Paassen
        date            : 170205
        description     : Peer Information connected udp nodes
        copyright       : (c) 2017-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated UDPPeerInfo.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_UDPPeerInfo
#endif
#include <stringoptions.h>
#include <inttypes.h>
#include <SimTime.hxx>
#ifdef MASTER_DCO_UDPPeerInfo
#undef MASTER_DCO_UDPPeerInfo
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Start information for a peer joining a replicator network.
    */
struct UDPPeerInfo
{
  /** typedef for internal reference */
  typedef UDPPeerInfo __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** network address for cyclic communication */
  vstring url;

  /** address of peer, as detected by master */
  vstring peer_if;

  /** datapacket size */
  uint32_t message_size;

  /** cycle where participation is asked */
  uint32_t join_cycle;

  /** time granule value, must match between nodes */
  double time_granule;

  /** master's interval value */
  dueca::TimeTickType interval;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  UDPPeerInfo();

  /** Constructor with arguments */
  UDPPeerInfo(
        const vstring& url,
        const vstring& peer_if,
        const uint32_t& message_size,
        const uint32_t& join_cycle,
        const double& time_granule,
        const dueca::TimeTickType& interval);

  /** copy constructor. */
  UDPPeerInfo(const UDPPeerInfo& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an UDPPeerInfo from amorphous storage. */
  UDPPeerInfo(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~UDPPeerInfo();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, UDPPeerInfo*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the UDPPeerInfo into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the UDPPeerInfo into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const UDPPeerInfo& ref) const;

  /** unpacks the UDPPeerInfo from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for UDPPeerInfo
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const UDPPeerInfo& o) const;

  /** Test for inequality. */
  inline bool operator != (const UDPPeerInfo& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  UDPPeerInfo& operator=(const UDPPeerInfo& o);

  /** prints the UDPPeerInfo to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::UDPPeerInfo& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::UDPPeerInfo& o,
                         const dueca::UDPPeerInfo& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::UDPPeerInfo& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::UDPPeerInfo& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::UDPPeerInfo& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::UDPPeerInfo>();
template <>
inline const char* dueca::getclassname<const dueca::UDPPeerInfo>()
{ return dueca::getclassname<dueca::UDPPeerInfo>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    UDPPeerInfo is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::UDPPeerInfo> : public dco_isnested { };
};

#endif


